#include "stdafx.h"
#include "Model.h"
#include "math.h"
#include "time.h"
#include "stdlib.h"

int R[4096][6][100];


// RIV
//	0-MoneyPay, 1-TimePay,
// IV
//	0-MoneyDesire, 1-TimeDesire   
// B
//	0-Kill, 1-Up, 2-Down, 3-Same, 4-Threat, 5-Leave, 6-Deal
// RM
//	0-DiffBoth, 1-DiffSelf, 2-WayMarket, 3-Deadline, 4-Kill
// S
//  0-Highest, 1-Lowest, 3-Optimum, 2-Deadline

CModel::CModel()
{
}
CModel::CModel(CEnvironment* p, int n)
{
	env = p;
	AgentIndex = n;
}
CModel::~CModel()
{
}

void CModel::InitBehavior(const char buf[20])
{
	CFile f;
	char bigbuf[512];
	f.Open(buf,CFile::modeRead);
	CArchive ar(&f,CArchive::load,512,bigbuf );
	char str[80];
	char *token;
	int i;

	// RIV
	ar.ReadString(str,80);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_NumOfRIV = atoi(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_RIV[RIV_MoneyPay].val = atof(token);	// 100 dollars
	token = strtok(NULL," ");
	m_RIV[RIV_TimePay].inc = atof(token);	// 10 day
	m_RIV[RIV_TimePay].val = 0;

	// IV
	ar.ReadString(str,80);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_NumOfIV = atoi(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_IV[IV_MoneyDesire].val = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].damp = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].growth = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].gain[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].gain[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].gain[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].gain[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].gain[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].gain[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_MoneyDesire].gain[B_Deal] = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_IV[IV_TimeDesire].val = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].damp = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].growth = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].gain[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].gain[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].gain[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].gain[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].gain[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].gain[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_IV[IV_TimeDesire].gain[B_Deal] = atof(token);

	// B
	ar.ReadString(str,80);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_NumOfB = atoi(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_B[B_Kill].val = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].oldval = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].inhibit[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].inhibit[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].inhibit[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].inhibit[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].inhibit[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].inhibit[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Kill].inhibit[B_Deal] = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_B[B_Up].val = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].oldval = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].inhibit[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].inhibit[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].inhibit[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].inhibit[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].inhibit[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].inhibit[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Up].inhibit[B_Deal] = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_B[B_Down].val = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].oldval = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].inhibit[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].inhibit[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].inhibit[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].inhibit[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].inhibit[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].inhibit[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Down].inhibit[B_Deal] = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_B[B_Same].val = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].oldval = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].inhibit[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].inhibit[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].inhibit[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].inhibit[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].inhibit[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].inhibit[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Same].inhibit[B_Deal] = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_B[B_Threat].val = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].oldval = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].inhibit[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].inhibit[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].inhibit[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].inhibit[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].inhibit[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].inhibit[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Threat].inhibit[B_Deal] = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_B[B_Leave].val = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].oldval = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].inhibit[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].inhibit[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].inhibit[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].inhibit[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].inhibit[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].inhibit[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Leave].inhibit[B_Deal] = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_B[B_Deal].val = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].oldval = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].inhibit[B_Kill] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].inhibit[B_Up] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].inhibit[B_Down] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].inhibit[B_Same] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].inhibit[B_Threat] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].inhibit[B_Leave] = atof(token);
	token = strtok(NULL," ");
	m_B[B_Deal].inhibit[B_Deal] = atof(token);
	
	// RM
	ar.ReadString(str,80);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_NumOfRM = atoi(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_RM[RM_DiffBoth].backT = atoi(token);
	token = strtok(NULL," ");
	for(i=0; i<m_RM[RM_DiffBoth].backT; i++)
		m_RM[RM_DiffBoth].val[i] = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_DiffBoth].findMax = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_DiffBoth].findMin = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_RM[RM_DiffSelf].backT = atoi(token);
	token = strtok(NULL," ");
	for(i=0; i<m_RM[RM_DiffSelf].backT; i++)
		m_RM[RM_DiffSelf].val[i] = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_DiffSelf].findMax = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_DiffSelf].findMin = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_RM[RM_WayMarket].backT = atoi(token);
	token = strtok(NULL," ");
	for(i=0; i<m_RM[RM_WayMarket].backT; i++)
		m_RM[RM_WayMarket].val[i] = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_WayMarket].findMax = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_WayMarket].findMin = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_RM[RM_Deadline].backT = atoi(token);
	token = strtok(NULL," ");
	for(i=0; i<m_RM[RM_Deadline].backT; i++)
		m_RM[RM_Deadline].val[i] = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_Deadline].findMax = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_Deadline].findMin = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_RM[RM_Kill].backT = atoi(token);
	token = strtok(NULL," ");
	for(i=0; i<m_RM[RM_Kill].backT; i++)
		m_RM[RM_Kill].val[i] = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_Kill].findMax = atof(token);
	token = strtok(NULL," ");
	m_RM[RM_Kill].findMin = atof(token);

	// LI
	ar.ReadString(str,80);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_LI[B_Kill].val = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Kill].damp = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Kill].growth = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Kill].bRate = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_LI[B_Up].val = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Up].damp = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Up].growth = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Up].bRate = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_LI[B_Down].val = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Down].damp = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Down].growth = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Down].bRate = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_LI[B_Same].val = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Same].damp = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Same].growth = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Same].bRate = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_LI[B_Threat].val = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Threat].damp = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Threat].growth = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Threat].bRate = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_LI[B_Leave].val = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Leave].damp = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Leave].growth = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Leave].bRate = atof(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_LI[B_Deal].val = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Deal].damp = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Deal].growth = atof(token);
	token = strtok(NULL," ");
	m_LI[B_Deal].bRate = atof(token);

	// S
	ar.ReadString(str,80);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_NumOfS = atoi(token);
	ar.ReadString(str,80);
	token = strtok(str," ");
	m_S[S_Highest].val = atof(token);
	token = strtok(NULL," ");
	m_S[S_Lowest].val = atof(token);
	token = strtok(NULL," ");
	m_S[S_Optimum].val = atof(token);
	token = strtok(NULL," ");
	m_S[S_Deadline].val = atof(token);
}

void CModel::UpdateRIV()  // time spent on this negociation
{
//	m_RIV[RIV_MoneyPay] 
	m_RIV[RIV_TimePay].val += m_RIV[RIV_TimePay].inc;
	if(m_RIV[RIV_TimePay].val>1) m_RIV[RIV_TimePay].val = 1;
}
void CModel::UpdateIV() // mental state
{
	// update the internal variable's value
	for(int i=0; i<m_NumOfIV; i++) {
		m_IV[i].val = m_IV[i].val*m_IV[i].damp 
						+ m_IV[i].growth;
		for(int j=0; j<m_NumOfB; j++) {
			m_IV[i].val -= (m_IV[i].gain[j]
							* m_B[j].val);
		}
		if(m_IV[i].val<0) m_IV[i].val=0;	// original paper not write these
		if(m_IV[i].val>1) m_IV[i].val=1;
	}
}
void CModel::UpdateLI()  // level of interest to a behavior
{
	// update the level of interest's value
	double a;
	for(int i=0; i<m_NumOfB; i++) {
		a = m_LI[i].val*m_LI[i].damp + m_LI[i].growth
			- m_B[i].val*m_LI[i].bRate;
		if(a>1) a=1.0;
		else if(a<0) a=0.0;
		m_LI[i].val = a;
	} 
}
void CModel::UpdateRM()  // model external stimulus
{
	// update releasing mechanizm
	int i,j;
	for(j=0; j<m_NumOfRM; j++) {
		for(i=(m_RM[j].backT-2); i>=0; i--) {
			m_RM[j].val[i+1] = m_RM[j].val[i];
		}
		m_RM[j].val[0] = RMFind(j, m_RM[j].findMax,
							m_RM[j].findMin);	// fill the 1st element
		m_RM[j].val[0] = RMTemporalFilterSum(m_RM[j].val, 
								m_RM[j].backT);	// average all
	}
}
double CModel::RMFind(int g, double max, double min)
{
// RM
//	0-DiffBoth, 1-DiffSelf, 2-WayMarket
	double diff;
	if(g==RM_DiffBoth) {
		diff = fabs(env->Agent[0]->m_RIV[RIV_MoneyPay].val 
				- env->Agent[1]->m_RIV[RIV_MoneyPay].val);
		if(diff>=50) return 0.95;
		else if(diff>=25) return 0.7;
		else if(diff>=10) return 0.4;
		else if(diff>=5) return 0.2;
		else if(diff>=2) return 0.1;
		else return 0.05;
	}
	else if(g==RM_DiffSelf) {
		diff = fabs(m_RIV[RIV_MoneyPay].val - m_S[S_Optimum].val);
		if(diff>=200) return 0.95;
		else if(diff>=100) return 0.8;
		else if(diff>=50) return 0.5;
		else if(diff>=25) return 0.3;
		else if(diff>=10) return 0.1;
		else return 0.05;
	}
	else if(g==RM_WayMarket) {
		return 0.5;
	}
	else if(g==RM_Deadline) {
		if(m_S[S_Deadline].val<=15) return 0.95;
		else if(m_S[S_Deadline].val<=30) return 0.8;
		else if(m_S[S_Deadline].val<=50) return 0.6;
		else if(m_S[S_Deadline].val<=80) return 0.4;
		else if(m_S[S_Deadline].val<=150) return 0.2;
		else return 0.05;
	}
	else if(g==RM_Kill) {
		if(env->Agent[1-AgentIndex]->m_BOut==B_Kill)
			return 1;
		else return 0;
	}
	else return 0.0;
}
double CModel::RMTemporalFilterSum(double oldfind[MAX_RMBACKT], int t)
{
	double sum=0;
	for(int i=0; i<t; i++) {
		sum += oldfind[i];
	}
	sum /= t; 
	return sum;
}
void CModel::UpdateB()
{
	m_B[B_Kill].val = m_LI[B_Kill].val * 
			(0.5*m_RM[RM_DiffBoth].val[0]
			+0.5*(1-m_IV[IV_TimeDesire].val))*0.7;
	
	// wXC
	if((m_RIV[RIV_MoneyPay].val < env->Agent[1-AgentIndex]->m_RIV[RIV_MoneyPay].val)
		&& (m_RIV[RIV_MoneyPay].val < m_S[S_Highest].val)) {
		m_B[B_Up].val = m_LI[B_Up].val * 
			(0.2*m_RM[RM_DiffBoth].val[0]
			+0.3*m_RIV[RIV_TimePay].val
			+0.2*m_RM[RM_Kill].val[0]
			+0.3*m_IV[IV_TimeDesire].val);
	}
	else m_B[B_Up].val = 0;
	
	//wX
//	if((m_RIV[RIV_MoneyPay].val > env->Agent[1-AgentIndex]->m_RIV[RIV_MoneyPay].val)
//		&& (m_RIV[RIV_MoneyPay].val > m_S[S_Lowest].val)) {
	if((m_RIV[0].val > env->Agent[1-AgentIndex]->m_RIV[0].val)
		&& (m_RIV[0].val > m_S[1].val)) {
		m_B[B_Down].val = m_LI[B_Down].val *
			(0.2*m_RM[RM_DiffBoth].val[0]
			+0.3*m_RIV[RIV_TimePay].val
			+0.2*m_RM[RM_Kill].val[0]
			+0.3*m_IV[IV_TimeDesire].val);
	}
	else m_B[B_Down].val = 0;

	m_B[B_Same].val = m_LI[B_Same].val * 
			(0.7*m_IV[IV_MoneyDesire].val
			+0.3*(1-m_IV[RIV_TimePay].val)/2);
	
	m_B[B_Threat].val = m_LI[B_Threat].val * 
			(0.7*m_RIV[RIV_TimePay].val
			 +0.3*m_RM[RM_Deadline].val[0]);
	
	if(m_RIV[RIV_TimePay].val==1) m_B[B_Leave].val = 1;
	else {
		m_B[B_Leave].val = m_LI[B_Leave].val *
				(0.2*(1-m_IV[IV_TimeDesire].val)
				+0.3*m_RIV[RIV_TimePay].val
				+0.3*m_RM[RM_Deadline].val[0]
				+0.2*m_RM[RM_DiffSelf].val[0]);
	}
	
	if((int)(m_RIV[RIV_MoneyPay].val) 
			== (int)(env->Agent[1-AgentIndex]->m_RIV[RIV_MoneyPay].val)) {
		m_B[B_Deal].val = 1;
	}
	else m_B[B_Deal].val = 0;


	int i;
	int ee = 2;		// just a variable
	while(ee>1) {
		ee = 0;
		//Kill
		for(i=0; i<m_NumOfB; i++) {
			if (i!=B_Kill)
			  m_B[B_Kill].val -= m_B[B_Kill].inhibit[i]*m_B[i].oldval;
		}
		if (m_B[B_Kill].val<0) m_B[B_Kill].val=0;
		else {
			ee++;
			m_BOut = B_Kill;
		}
		m_B[B_Kill].oldval = m_B[B_Kill].val;

		//Up
		for(i=0; i<m_NumOfB; i++) {
			if (i!=B_Up)
			  m_B[B_Up].val -= m_B[B_Up].inhibit[i]*m_B[i].oldval;
		}
		if (m_B[B_Up].val<0) m_B[B_Up].val=0;
		else {
			ee++;
			m_BOut = B_Up;
		}
		m_B[B_Up].oldval = m_B[B_Up].val;

		//Down
		for(i=0; i<m_NumOfB; i++) {
			if (i!=B_Down)
			  m_B[B_Down].val -= m_B[B_Down].inhibit[i]*m_B[i].oldval;
		}
		if (m_B[B_Down].val<0) m_B[B_Down].val=0;
		else {
			ee++;
			m_BOut = B_Down;
		}
		m_B[B_Down].oldval = m_B[B_Down].val;

		//Same
		for(i=0; i<m_NumOfB; i++) {
			if (i!=B_Same)
			  m_B[B_Same].val -= m_B[B_Same].inhibit[i]*m_B[i].oldval;
		}
		if (m_B[B_Same].val<0) m_B[B_Same].val=0;
		else {
			ee++;
			m_BOut = B_Same;
		}
		m_B[B_Same].oldval = m_B[B_Same].val;

		//Threat
		for(i=0; i<m_NumOfB; i++) {
			if (i!=B_Threat)
			  m_B[B_Threat].val -= m_B[B_Threat].inhibit[i]*m_B[i].oldval;
		}
		if (m_B[B_Threat].val<0) m_B[B_Threat].val=0;
		else {
			ee++;
			m_BOut = B_Threat;
		}
		m_B[B_Threat].oldval = m_B[B_Threat].val;

		//Leave
		for(i=0; i<m_NumOfB; i++) {
			if (i!=B_Leave)
			  m_B[B_Leave].val -= m_B[B_Leave].inhibit[i]*m_B[i].oldval;
		}
		if (m_B[B_Leave].val<0) m_B[B_Leave].val=0;
		else {
			ee++;
			m_BOut = B_Leave;
		}
		m_B[B_Leave].oldval = m_B[B_Leave].val;

		//Deal
		for(i=0; i<m_NumOfB; i++) {
			if (i!=B_Deal)
			  m_B[B_Deal].val -= m_B[B_Deal].inhibit[i]*m_B[i].oldval;
		}
		if (m_B[B_Deal].val<0) m_B[B_Deal].val=0;
		else {
			ee++;
			m_BOut = B_Deal;
		}
		m_B[B_Deal].oldval = m_B[B_Deal].val;
	}
	if(ee<1) {
		m_BOut = B_Same;
	}
}
void CModel::Modify() 
{
	double diff;
	if(m_BOut==B_Kill) {
		m_RIV[RIV_TimePay].val += 0.03;	// @
		if(m_RIV[RIV_TimePay].val>1) m_RIV[RIV_TimePay].val=1;
	}
	else if(m_BOut==B_Up) {
		diff = fabs(m_RIV[RIV_MoneyPay].val - env->Agent[1-AgentIndex]->m_RIV[RIV_MoneyPay].val);
		if(diff>2) {
			if(env->Agent[1-AgentIndex]->m_BOut==B_Threat) {
				m_RIV[RIV_MoneyPay].val += (int)diff*0.6;
				if(m_RIV[RIV_MoneyPay].val>m_S[S_Highest].val)
				m_RIV[RIV_MoneyPay].val=m_S[S_Highest].val;
			}
			else {
				m_RIV[RIV_MoneyPay].val += (int)diff*0.3;
				if(m_RIV[RIV_MoneyPay].val>m_S[S_Highest].val)
				m_RIV[RIV_MoneyPay].val=m_S[S_Highest].val;
			}
		}
		else {
			m_RIV[RIV_MoneyPay].val = env->Agent[1-AgentIndex]->m_RIV[RIV_MoneyPay].val;
		}
	}
	else if(m_BOut==B_Down) {
		diff = fabs(m_RIV[RIV_MoneyPay].val - env->Agent[1-AgentIndex]->m_RIV[RIV_MoneyPay].val);
		if(diff>2) {
			if(env->Agent[1-AgentIndex]->m_BOut==B_Threat) {
				m_RIV[RIV_MoneyPay].val -= (int)diff*0.6;
				if(m_RIV[RIV_MoneyPay].val>m_S[S_Highest].val)
					m_RIV[RIV_MoneyPay].val=m_S[S_Highest].val;
			}
			else {
				m_RIV[RIV_MoneyPay].val -= (int)diff*0.3;
				if(m_RIV[RIV_MoneyPay].val>m_S[S_Highest].val)
					m_RIV[RIV_MoneyPay].val=m_S[S_Highest].val;
			}
		}
		else {
			m_RIV[RIV_MoneyPay].val = env->Agent[1-AgentIndex]->m_RIV[RIV_MoneyPay].val;
		}
	}
	else if(m_BOut==B_Same) {
	}
	else if(m_BOut==B_Threat) {
		m_RIV[RIV_TimePay].val += 0.1;
		if(m_RIV[RIV_TimePay].val>1) m_RIV[RIV_TimePay].val=1;
	}
	else if(m_BOut==B_Leave) {
		signal = B_Leave;
	}
	else if(m_BOut==B_Deal) {
		signal = B_Deal;
	}
}
void CModel::UpdateAgent()
{
	UpdateRIV();
	UpdateIV();
	UpdateLI();
	UpdateRM();
	UpdateB();
	Modify();
}
//////////////////////////////////////
CEnvironment::CEnvironment()
{
}
CEnvironment::~CEnvironment()
{
}
void CEnvironment::InitEnvironment(char argA[20], int tableIndexA,
			char argB[20], int tableIndexB)
{	// Create two agents
	Agent[0] = new CModel(this,0);
	Agent[0]->InitBehavior(argA);	//˪
	// littley
	// Agent[0]->m_S[S_Highest].val = query(tableIndexA);
	// Agent[0]->m_S[S_Lowest].val = 
	// Agent[0]->m_S[S_Optimum].val = 
	// Agent[0]->m_S[S_Deadline].val = 
	Agent[0]->m_RIV[RIV_MoneyPay].val = Agent[0]->m_S[S_Lowest].val;
	Agent[1] = new CModel(this,1);
	Agent[1]->InitBehavior(argB);
	// Agent[1]->m_S[S_Highest].val = query(tableIndexB)
	// Agent[1]->m_S[S_Lowest].val = 
	// Agent[1]->m_S[S_Optimum].val = 
	// Agent[1]->m_S[S_Deadline].val = 
	Agent[1]->m_RIV[RIV_MoneyPay].val = Agent[1]->m_S[S_Highest].val;


	signal = B_NOSIGNAL ;
}
void CEnvironment::UpdateAll()
{
	for(int i=0; i<2; i++) {
		Agent[i]->UpdateAgent();
	}

	if((Agent[0]->signal==B_Leave) || (Agent[1]->signal==B_Leave)) {
		signal = B_Leave;
	}
	else if((Agent[0]->signal==B_Deal) && (Agent[1]->signal==B_Deal)) {
		signal = B_Deal;
	}
	else
		signal = B_NOSIGNAL;
}
void CEnvironment::CloseEnvironment()
{
	delete Agent[0];
	delete Agent[1];
}

CCA::CCA(char* buf)
{
  srand( (unsigned)time( NULL ) );
  fn=buf;
  InitialCA();
}

CCA::CCA()
{
  srand( (unsigned)time( NULL ) );
  fn=0;
  InitialCA();
}

CCA::~CCA()
{



}

void CCA::InitialCA()
{
  int i,j,k;


  //initial R
  for (i=0;i<4096;i++)
    for (j=0;j<6;j++)
	  for (k=0;k<100;k++)
      {
	    
        if (((float)rand()/(float)RAND_MAX)<0.5)
           R[i][j][k]=0;
		else
           R[i][j][k]=1;
      }

}


int CCA::RandRange(int upbound)
{
  
  return (int) (((float)rand()/(float)RAND_MAX)*(upbound));

}




void CCA::GeneX(int bc,int row,int clean)
{
  int i,j;
  
  if (clean) { 
	  for (i=0;i<100;i++)
		X[row][i]=0;

      i=0;
	  while (i<bc) {
		  j=RandRange(100);
          if (!X[row][j]) { 
			  X[row][j]=1;
			  i++;
		    }            

		 }
    }    	  



}

void CCA::InputX(char* buf)
{
    CFile f;
	char bigbuf[512];
	f.Open(buf,CFile::modeRead);
	CArchive ar(&f,CArchive::load,512,bigbuf );
	char str[80];
	char *token;
	int i;
    int bitcount;

	//line 0 to 4 ,do nothing
	for (i=0;i<5;i++)
	  ar.ReadString(str,80);

	//line 5 
    ar.ReadString(str,80);
    
	//initial Money_Desire
	token = strtok(str," ");
    bitcount=(int) (100*atof(token));
	GeneX(bitcount,0,1);

	//initial Money_Damp
	token = strtok(NULL," ");
    bitcount=(int) (100*atof(token));
	GeneX(bitcount,1,1);

	//initial Money_Growth
    token = strtok(NULL," ");
    bitcount=(int) (100*atof(token));
	GeneX(bitcount,2,1);

	//line 6
    ar.ReadString(str,80);

	//initial Time_Desire
	token = strtok(str," ");
    bitcount=(int) (100*atof(token));
	GeneX(bitcount,3,1);

	//initial Time_Damp
	token = strtok(NULL," ");
    bitcount=(int) (100*atof(token));
	GeneX(bitcount,4,1);

	//initial Time_Growth
    token = strtok(NULL," ");
    bitcount=(int) (100*atof(token));
	GeneX(bitcount,5,1);


	

}


void CCA::InputX()
{
  InputX("test1.txt");
}


int CCA::CheckX(int row,int pos)
{

  int count=0;
  
  if (X[row][((pos-1)+100)%100])
        count++;

  if (X[row][pos])
        count++;

  if (X[row][(pos+1)%100])
       count++;

  return count;

}


int CCA::XtoSRep(int pos)
{
  int i,sum=0;

  //X[0] is the least significant bit
  for (i=0;i<6;i++)
    {
      sum=sum+CheckX(i,pos)*(int) pow((double) 4,(double) i);
    }
  
  return sum;

}



void CCA::GeneS()
{

 int i;

 for (i=0;i<100;i++)
   S[i]=XtoSRep(i); 

}


void CCA::GeneY()
{
  int i,j;
  for (i=0;i<6;i++)
   for (j=0;j<100;j++)
       Y[i][j]=R[S[j]][i][j];
	   
}




void CCA::UpdateRule(int pf,float p)
{

  int j,k;
  //for check whether update or not
 

 
	  for (k=0;k<100;k++)
	    {
          if (pf) { //publishment

			        for (j=0;j<6;j++)
					   {
                          
						  //left
						  if (((float)rand()/(float)RAND_MAX)<=p)
						    {
							  if (R[S[k]][j][(k-1+100)%100])
								 R[S[k]][j][(k-1+100)%100]=0;
				              else
                                 R[S[k]][j][(k-1+100)%100]=1;
						    }
                         
                           if (((float)rand()/(float)RAND_MAX)<=p)
						    {
						       if (R[S[k]][j][k])
                                  R[S[k]][j][k]=0;
				               else
                                  R[S[k]][j][k]=1;
						    }

						  //right
						  if (((float)rand()/(float)RAND_MAX)<=p)
						    {
							   if (R[S[k]][j][(k+1)%100])
								  R[S[k]][j][(k+1)%100]=0;
							   else
								  R[S[k]][j][(k+1)%100]=1;
						    }
					   }

		          }
          else 
		      {    
			      //reward
			    for (j=0;j<6;j++)
	               {
		             //left 
					 if (((float)rand()/(float)RAND_MAX)<=p)
					    R[S[k]][j][(k-1+100)%100]=R[S[k]][j][k];

					 //right
                     if (((float)rand()/(float)RAND_MAX)<=p)
					    R[S[k]][j][(k+1)%100]=R[S[k]][j][k];

				    }
		       }
	     }  
}



//update X
void CCA::UpdateX()
{

   float t[6];
   int	count,i,j;
   int r;
   
   for (i=0;i<6;i++)
      {
        count=0;
		for (j=0;j<100;j++)
		   {  
			 if (Y[i][j])
		       count++;
		   }
         
		//bit # round up
		if ((r=(count%10))!=0)
            count=count-r+10;

        

		t[i]=(float) (((float) count/100)*0.1-0.05);
      }

     
    CFile f,wf;
	char bigbuf[512],wbuf[512];
    

	int sure=0;
	//make a temp fn if fn=0
	if (!fn)
	  {
		fn="test1.txt";
	    sure=1;
	  }  
     
    
	 
    f.Open(fn,CFile::modeRead);
	CArchive ar(&f,CArchive::load,512,bigbuf);
	
	

	wf.Open("test2.txt", CFile::modeCreate | CFile::modeWrite);
	CArchive war(&wf,CArchive::store,512,wbuf);
    
	char str[80];
	//int i;
	char* tmp;
    char* token;

	//do nothing 
	for (i=0;i<5;i++)
	   {
		tmp=ar.ReadString(str,80);
        strcat(str,"\n");		
        war.WriteString(str);
	   }

	//update money line
	ar.ReadString(str,80);


	token = strtok(str," ");
    float v=(float) atof(token)+t[0];
	

	token = strtok(NULL," ");
	float damp=(float) atof(token)+t[1];

	token = strtok(NULL," ");
	float growth=(float) atof(token)+t[2];

	sprintf(str,"%.2f %.2f %.2f 0 0 0 0 0 0 0\n",v,damp,growth);
    war.WriteString(str);
    
	//update time line
    ar.ReadString(str,80);

	token = strtok(str," ");
    v=(float) atof(token)+t[3];

	token = strtok(NULL," ");
	damp=(float) atof(token)+t[4];

	token = strtok(NULL," ");
	growth=(float) atof(token)+t[5];
   

	sprintf(str,"%.2f %.2f %.2f 0 0 0 0 0 0 0\n",v,damp,growth);
    war.WriteString(str);


    

	//do nothing 
	for (i=0;i<27;i++)
	   {
		ar.ReadString(str,80);
		strcat(str,"\n");
        war.WriteString(str);
	   }
   
    ar.Close();
	war.Close();
    f.Close();
	wf.Close();


	CFile::Remove(fn);
	CFile::Rename("test2.txt",fn);
        
    
    //recover fn
	if (!strcmp(fn,"test1.txt")&& sure)
       fn=0;
}




//something wrong out of boundary
int CCA::ColShuffle(int col,int bitn,int bitm)
{

  int i,tmp[7]; //tmp is stored col's binary representation
  int q,r;

  //tmp[0] is least significant bit
  
  q=col;
  r=0;

  for (i=0;i<7;i++)
     { 
	   r=q%2;
	   q=q/2;
     }	
  
  int c;

  if (bitn!=bitm)
  { 
	c = tmp[bitn] ;
    tmp[bitn]=tmp[bitm];
    tmp[bitm]=c;
  } 

  q=0;

  for (i=0;i<7;i++)
     { 
	  if (tmp[i]) 
	    q=q+tmp[i]*(int) pow((double) 2,(double)i);
     }
  return q;

}

void CCA::Shuffle()
{
  int i,j,k,c;
  int n,m;
  int check[100];

  n=RandRange(7);
  m=RandRange(7);
 
  //ready to do some check to col
  for (i=0;i<100;i++)
    check[i]=0;

  //according to col
  for (k=0;k<100;k++)
     {
	   
	   
       //check[k]=ColShuffle(k,n,m);
	   //check[check[k]]=k;


       //if (!check[k])
         //check[k]=-1;

	   //this differs from how to shuffle
	   if (k && !check[k])
	     { 
		     check[k]=ColShuffle(k,n,m);
	         check[check[k]]=k;

           for (i=0;i<4096;i++)
	          for (j=0;j<6;j++)
			     { 
                   c = R[i][j][k];
				   R[i][j][k]=R[i][j][check[k]];
				   R[i][j][check[k]]=c;
       
		          }
		  }
      }
  }















